#include <windows.h>
#include <stdio.h>
#include <vector>
#include <string>
#include <algorithm>

int main(int n_arg_num, const char **p_arg_list)
{
	std::vector<std::basic_string<wchar_t> > device_list;

	try {
		std::vector<wchar_t> buffer;
		buffer.resize(8);
		for(;;) {
			DWORD n_result = QueryDosDevice(NULL, &buffer[0], buffer.size());
			if(n_result != ERROR_INSUFFICIENT_BUFFER && n_result > 0 && n_result < buffer.size())
				break;
			buffer.resize(2 * buffer.size());
		}
		// get list of devices

		const wchar_t *p_s_string_list = &buffer[0];
		while(*p_s_string_list) {
			device_list.push_back(std::basic_string<wchar_t>(p_s_string_list));
			p_s_string_list += wcslen(p_s_string_list) + 1;
		}
		// convert it to more convenient data structure

		std::sort(device_list.begin(), device_list.end());
		// sort it
	} catch(std::bad_alloc&) {
		fprintf(stderr, "error: not enough memory\n");
		return -1;
	}

	for(size_t i = 0, n = device_list.size(); i < n; ++ i)
		wprintf(L"\\\\.\\%s\n", device_list[i].c_str());
	// print list of devices

	return 0;
}
